var Dfe07900_Controle_de_Arquivos_Xml_Controller = function(ScreenService, templateManager, General, metaDataFactory, restEngine) {
    
    var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    
    this.cancelar = function(widget) {
        if (widget.currentRow.__is_new) {
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
            widget.list();
        }
    };
    
    this.salvar = function(widget){
        var row = Util.clone(widget.currentRow, ignoredKeys);
        if (widget.isValid()) {
            General.callRestEngine('df_entrada#/novoDirArqXML', "Row", row).then(function() {
				widget.activate();
				if (widget.currentRow.__is_new) {
					widget.list();  
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.view();
				}
			}.bind(this), this.errorRequest);
        }
    };
    
    this.onEnterOnce = function(widget) {
        General.callRestEngine('df_entrada#/getArquivosXML', "FilterData", widget.dataSourceFilter).then((response) => {
            
            widget.dataSource.data = response.dataset.arquivos_xml;
            General.callRestEngine('df_entrada#/getIsSaas', "FilterData", []).then( success => {
                if(success.dataset.isSaas[0]) {
                    widget.getParent().getField('DSDIRIMPARQXML').isVisible = false;
                    widget.getAction("adicionarDiretorio").isVisible = false;
                }
                else {
                    if(response.dataset.arquivos_xml[0].RAIZ){
                        widget.getParent().currentRow.DSDIRIMPARQXML = response.dataset.arquivos_xml[0].RAIZ;
                    } else {
                        ScreenService.showMessage("Diretório não parametrizado, favor adicionar um diretório base na tela \"Parametros de Documentos Fiscais de Entrada\"");
                    }
                }
                widget.getParent().redraw();
                widget.reload();
            });
        }).catch(this.errorRequest);  
    };
    
    this.openWidgetUpload = function(widget){
        var widgetUpload = templateManager.container.getWidget('widgetUploadXML');
        widgetUpload.currentRow = { __is_new: true };
        widgetUpload.isVisible  = true;
        ScreenService.openSwipe(widgetUpload).then(function(){
            widgetUpload.newRow();
        });
        
    };
    
    this.closeUploadSwipe = function(widget){
        ScreenService.closeSwipe();
        templateManager.container.getWidget('arvoreArquivosNfe').activate();
        widget.isVisible = false;
        
    };
    
    this.upload = function(widget){
        
        if(!widget.isValid()){
            return;
        }
        let row = widget.currentRow;
        let widgetReload = templateManager.container.getWidget('arvoreArquivosNfe');
        row.DIR = (widget.getParent().currentRow.DIR_FULL) ? widget.getParent().currentRow.DIR_FULL : widget.getParent().getParent().currentRow.DSDIRIMPARQXML;
        if(row.DIR || row.isSaas){
            General.callRestEngine('df_entrada#/uploadArqXML', "Row", row).then(function() {
                ScreenService.closeSwipe();
                widgetReload.resizeGridColumns(true);
                widgetReload.reload();
            }.bind(this), this.errorRequest);
        } else{
            ScreenService.closeSwipe();
            ScreenService.showMessage("Diretório não definido, não é possivel fazer o upload");
        }
        
    };
    
    this.download = function(widget){
        var row = Util.clone(widget.currentRow, ignoredKeys);
        let params = "/downloadArqXML?requestType=Row&row[DSARQUIVO]=" + row.DOWNLOAD;
        
        window.open(
            window.serviceUrls.filter(
                (x) => { return x.package == 'df'; }
            )[0].baseUrl + params
        );
        
    };
    
    this.excluir = function(widget){
        var row = Util.clone(widget.currentRow, ignoredKeys);
        General.callRestEngine('df_entrada#/excluirArqXML', "Row", row).then(function() {
            ScreenService.closeSwipe().then(function() {
                widget.list();
                widget.reload();
            });
        }.bind(this), this.errorRequest);
    };
    
    this.errorRequest = function(error) {
        if (error.data) {
            ScreenService.showMessage(error.data.error);
        } else {
            ScreenService.showMessage(error);
        }
        ScreenService.hideLoader();
    };
    
    this.novoDiretorio = function(widget){
        widget.newRow();
    };
};
Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe07900_Controle_de_Arquivos_Xml_Controller', Dfe07900_Controle_de_Arquivos_Xml_Controller);
});