var SelectInlineController = function(templateManager, $scope, $rootScope, metaDataFactory,  ScreenService, ZhUtil, SelectService, ZHPromise, maskEngine, EventChildPropagation) {

    var self = this;
    
    this.setScopeField = function(field) {
        if(!$scope.field) $scope.field = field;  
    };
    
    this.initFieldSelectInline = function(field) {
        this.setScopeField(field);
    };

    this.showCloseXIconSelect = function(row, fieldName) {
    	if(row[fieldName]) return true;
    	else return false;
    };
    
    this.showSearchIconSelect = function(row, fieldName) {
    	if(row[fieldName]) return false;
    	else return true;
    };
    
    this.clearCurrentRowField = function(fields, widget, $event, row, element, field) {
    	$event.stopPropagation();
    	if(!field.conditions) {
    		widget.currentRow = row;
	    	fields.forEach((field) => {
	    		field = field.name;
		    	if(!widget.currentRow['changed_'.concat(field)]) widget.currentRow['changed_'.concat(field)] = widget.currentRow[field]; 
		        widget.currentRow[field.concat('_inline')] = ''; 
		        widget.currentRow[field] = ''; 
		        if(widget.mode !== 'inline_edit') {
	                widget.inlineEdit();
	                templateManager.updateTemplate();
		        }
	        });
	        widget.lastInlineEditingElement = element.element;
    	}
        else {
        	let valid = true;
        	field.conditions.forEach((condition) => {
        		if(condition.operator == '=' || condition.operator == '==') {
        			valid (valid && row[condition.columnName] == condition.columnValue);
        		}
        		else if(condition.operator == '!=' || condition.operator == '<>') {
        			valid = (valid && row[condition.columnName] != condition.columnValue); 
        		}
        	});
        	if(valid) {
        		widget.currentRow = row;
		    	fields.forEach((field) => {
		    		field = field.name;
			    	if(!widget.currentRow['changed_'.concat(field)]) widget.currentRow['changed_'.concat(field)] = widget.currentRow[field]; 
			        widget.currentRow[field.concat('_inline')] = ''; 
			        widget.currentRow[field] = ''; 
			        if(widget.mode !== 'inline_edit') {
		                widget.inlineEdit();
		                templateManager.updateTemplate();
			        }
		        });
		        widget.lastInlineEditingElement = element.element;
        	}
        	else ScreenService.showMessage(field.errorMessage);
        }
    	
    };
    
    this.openField = function(field, $event ,row, isSpan) {
    	if(!field.conditions) {
    		this.openSelect(field, $event, isSpan);
    	}
        else {
        	let valid = true;
        	field.conditions.forEach((condition) => {
        		if(condition.operator == '=' || condition.operator == '==') {
        			valid (valid && row[condition.columnName] == condition.columnValue);
        		}
        		else if(condition.operator == '!=' || condition.operator == '<>') {
        			valid = (valid && row[condition.columnName] != condition.columnValue); 
        		}
        	});
        	if(valid) this.openSelect(field, $event, isSpan);
        	else ScreenService.showMessage(field.errorMessage);
        }
	};
	 
	this.openSelect = function(field, $event, isSpan) {
		if(isSpan) field.widget.lastInlineEditingElement = $event.toElement.parentElement.parentElement;
        else field.widget.lastInlineEditingElement = $event.toElement;
		var defer = ZHPromise.defer();
		var actions = [{
			"label": ScreenService.i18n("Cancel"),
			"showAsAction": "back",
			"isVisible": true,
			"showOnForm": true,
			"showOnList": true,
			"hideIcon": true,
			"events": [{
				"name": "ActionEvent",
				"code": "ScreenService.closePopup(); args.owner.widget.afterClosePopup(args.owner.widget.selectField);",
				"id": 9998
			}]
		}];

		if (field.showAddButtonAs == 'action') {
			actions.push({
				"icon": "plus",
				"label": field.addButtonText,
				"showAsAction": "always|edit|checked_rows|view",
				"isVisible": true,
				"showOnForm": true,
				"showOnList": true,
				"events": [{
					"name": "ActionEvent",
					"code": "args.owner.widget.onAdd()",
					"id": 9999
				}]
			});
		}

		innerSearch("", field);

		var template;
		if (!field.showSelectAs) {
			template = "widget/list.html";
		} else if (field.showSelectAs === "tree") {
			template = "widget/tree/grid.html";
		} else {
			template = "widget/" + field.showSelectAs + ".html";
		}

		var fields;
		if (field.fields && field.fields.length) {
			fields = field.fields;
		} else {
			fields = [{
				"label": field.sourceLabel,
				"name": field.descriptionField,
				"showOnList": true,
				"mask": field.mask
			}];
		}

		var isToReload = !!(field.selectWidget && Util.objectHasAnyValue(field.selectWidget.searchCriteria));
		if (!field.selectWidget) {
			var widgetEvents = [{
				"name": "WidgetAfterMoveRow",
				"code": "args.owner.setSelected(args);",
				"id": 9999
			}];
			field.selectWidget = metaDataFactory.widgetFactory({
				"id": 0,
				"name": "Widget",
				"label": field.label,
				"template": template,
				"container": field.widget.container,
				"isVisible": true,
				"popupNoBlock": false,
				"showDescriptionOrder": false,
				"floatingControl": {
					"openSearch": !Util.isMobile(),
					"defaultSearchField": field.defaultSearchField || field.descriptionField,
					"pdfAction": false,
					"xlsAction": false,
					"searchAction": true,
					"customizationAction": {
						"filter": false,
						"layout": false,
						"view": false
					}
				},

				"parentProperty": field.parentProperty,
				"primaryProperty": field.primaryProperty,
				"expandingProperty": field.expandingProperty,
				"breadcrumbProperty": field.breadcrumbProperty,

				"order": field.order,
				"reverse": field.reverse,
				"bringGroupsCollapsed": field.bringGroupsCollapsed,
				"orderFromGroups": field.orderFromGroups,
				"selectField": field,
				"showCheckbox": false,
				"onAdd": field.onAdd,
				"showAddButtonAs": field.showAddButtonAs,
				"addButtonText": field.addButtonText,
				"noMatchText": field.noMatchText,
				"searchNoMatchText": field.searchNoMatchText,
				"fields": fields,
				"dataSource": field.dataSource,
				"dataSourceFilter": field.dataSourceFilter,
				"itemsPerPage": field.itemsPerPage,
				"searchWithPagination": Util.isUndefinedOrNull(field.searchWithPagination) ? true : field.searchWithPagination,
				"hasPagination": Util.isUndefinedOrNull(field.hasPagination) ? true : field.hasPagination,
				"onDemand": field.onDemand,
				"allowSelectOnlyLastChild": field.allowSelectOnlyLastChild,
				"searchCriteria": field.searchCriteria,

				"actions": actions,
				"events": EventChildPropagation.propagate(widgetEvents, field),

				"styles": field.selectWidgetStyles
			});
			field.selectWidget.setSelected = setSelected;
			field.selectWidget.afterClosePopup = afterClosePopup;
			isToReload = !!(field.dataSource && field.dataSource.lazyLoad);
		}

		if (isToReload) {
			field.selectWidget.searchCriteria = {};
			field.selectWidget.searchList = "";
			field.reload().then(defer.resolve, defer.resolve);
		} else {
			defer.resolve();
		}

		ScreenService.openPopup(field.selectWidget);
		return defer.promise;	
	};
    
    
    function innerSearch(selectListSearch, field) {
		if (Util.isArray(field.filterDefinitions) && field.filterDefinitions.length) {
			var dataSource = field.dataSource;
			var filter = ZhUtil.buildFiltersInField(field, selectListSearch);
			dataSource.filter(filter, function(data) {
				dataSource.data = data;
				templateManager.updateTemplate();
			});
		}
	}
	
	var isLastChild = function(row){
		return row._childCount === 0;
	};

	
	function outDataInlineSelect(selectWidget, widgetOutData, fields, changed) {
        fields.forEach((field) => {
           field = field.name;
           if(!selectWidget.currentRow['changed_'.concat(field)]) widgetOutData.currentRow['changed_'.concat(field)] = widgetOutData.currentRow[field]; 
           widgetOutData.currentRow[field.concat('_inline')] = selectWidget.currentRow[field]; 
           if(!widgetOutData.currentRow.changed) widgetOutData.currentRow.changed = true;
           widgetOutData.currentRow[field] = selectWidget.currentRow[field]; 
        });
        if(changed == false) selectWidget.changed = true;
        if(widgetOutData.mode !== 'inline_edit') {
            widgetOutData.inlineEdit();
            templateManager.updateTemplate();
        }
	}
	
	function setSelected(args) {
	    var row = args.row;
		var field = args.owner.selectField;
		outDataInlineSelect(field.selectWidget, field.widget, field.fields, field.widget.changed);
		
		ScreenService.closePopup();

		if (field.element) {
			field.element.focus();
		}

		(field.outData ? changeByOut : changeByName)(field, row);
		field.dataSource.clearCheckedRows();
		field.dataSource.addCheckedRows(row);
		setChanged(field);

		if (field._afterSelected) {
			field._afterSelected(row);
		}
		if (field.change) {
			field.change();
		}
		
	}
	
	function afterClosePopup(field) {
		if (field.element) {
			field.element.focus();
		}
	}
	
	function changeByName(field, row) {
		var valueField = field.valueField ? field.valueField : field.name;
		var descriptionField = field.descriptionField ? field.descriptionField : field.name;
		field.widget.currentRow[valueField] = row[valueField];
		field.widget.currentRow[field.name] = row[descriptionField];
	}

	function changeByOut(field, row) {
		if (field.widget.currentRow) {
			var outData = field.outData || {};

			Object.keys(outData).forEach(function(key) {
				if (Array.isArray(outData[key])) {
					outData[key].forEach(function(valueKey) {
						field.widget.currentRow[valueKey] = row[key];
					});
				} else {
					field.widget.currentRow[outData[key]] = row[key];
				}
			});
		}
	}
	
	var setChanged = function(field) {
		field.widget.currentRow.changed = true;
	};
	
	$scope.$watchCollection('field.dataSourceFilter', propagateFieldDataSourceFilterToSelectWidget);
	function propagateFieldDataSourceFilterToSelectWidget(fieldDataSourceFilter) {
		if ($scope.field.selectWidget) {
			$scope.field.selectWidget.dataSourceFilter = fieldDataSourceFilter;
		}
	}
};
