function CodigoSituacaoOperacaoSimples() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Documentos Fiscais',
			'Controle Fiscal']);
		geral.esperarLoading();
		geral.selectNative('IDENTRSAIDOP', 'Entrada');
	};

	this.editaOperacao = (CST, CFOP) => {
		geral.selectNative('IDOBINFCSTICMENT', CST);
		geral.selectNative('IDOBINFCSTCFOPEN', CFOP);
	};


	this.adicionar = (produto, CSOSN, grupoFiscal, operInterestadual) => {
		protractorHelper.click(element(by.css('#NMPRODUTO .editable')));
		geral.searchAndClickGridField('NMPRODUTO', produto, 'NMPRODUTO');
		geral.selectNative('CDFISCOPERSN', CSOSN);
		protractorHelper.click(element(by.css('#DSGRUPOFISC .editable')));
		geral.searchAndClickGridField('DSGRUPOFISC', grupoFiscal, 'DSGRUPOFISC');
		geral.selectNative('IDCSOSNINTEREST', operInterestadual);
	};

	this.editaStiuacaoTributaria = (CST, obrigaValorImposto) => {
		geral.selectNative('IDUTILIZACST', CST);
		geral.selectNative('IDOBRVRIMPOS', obrigaValorImposto);
	};
}

module.exports = new CodigoSituacaoOperacaoSimples();
